namespace Providers

open ProviderImplementation.ProvidedTypes
open FSharp.Core.CompilerServices
open System.Reflection

[<assembly: TypeProviderAssembly>]do()

[<TypeProvider>]
type public ConstantTypeProvider(config) as this =
  inherit TypeProviderForNamespaces(config)

  do
    let param = ProvidedStaticParameter("value", typeof<obj>);
    let thisAssembly = Assembly.GetExecutingAssembly()
    let namespaceName = typeof<ConstantTypeProvider>.Namespace
    let definition = ProvidedTypeDefinition(thisAssembly, namespaceName, "Const", Some typeof<obj>)

    let makeType (typeName: string) (parameterValues: obj array) =
        let definition = ProvidedTypeDefinition(thisAssembly, namespaceName, typeName, Some typeof<obj>)
        let value = parameterValues[0]
        //failwith (sprintf "%A" parameterValues[0])
        definition.AddMember(ProvidedField.Literal("Value", value.GetType(), value))
        this.AddNamespace(namespaceName, [definition])
        definition

    definition.DefineStaticParameters([param], makeType)
    this.AddNamespace(namespaceName, [definition])
